/**
 * January 2013 Long Challenge at Codechef
 *
 * Problem:     KILOWHAT - A Fence for Byteland
 * Author:      Anton Lunyov (Tester and Editorialist)
 * Complexity:  O(N * log N)
 * Timing:      0.00 out of 1.00
 * Score:       23.721313
 *
 * Description:
 * We sort all input points,
 * add two points (maxX,maxY+1) and (minX-1,maxY+1) to the end
 * and print thus obtained list of points
 */
#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

int main() {
	int N;
	cin >> N;
	// there will be at most 200 points in the input
	pair<int,int> A[200];
	// the coordinates of points are in [1,1000] hence
	// we use 0 and 1001 as init for max and min respectively
	int minX = 1001;
	int maxX = 0;
	int maxY = 0;
	for (int i = 0; i < N; ++i) {
		// Z is either 1000 or 1024 but we ignore it here
		int X, Y, Z;
		cin >> X >> Y >> Z;
		A[i] = make_pair(X, Y);
		minX = min(minX, X);
		maxX = max(maxX, X);
		maxY = max(maxY, Y);
	}
	sort(A, A + N);
	cout << N + 2 << endl;
	for (int i = 0; i < N; ++i) {
		cout << A[i].first << " " << A[i].second << "\n";
	}
	cout << maxX     << " " << maxY + 1 << "\n";
	cout << minX - 1 << " " << maxY + 1 << "\n";
	return 0;
}
